unit klassen;

interface

uses classes, sysutils, windows;

type


tmystr=string[50];  //String mit 50 Zeichen als Datentyp fixieren fr Filestream


Tauto=class
private
  marke,typ:tmystr;
  baujahr,km:integer;
  preis:real;
public
 procedure set_marke(s:tmystr);
 procedure set_typ(s:tmystr);
 procedure set_baujahr(b:integer);
 procedure set_km(k:integer);
 procedure set_preis(p:real);
 procedure set_all(au:Tauto);
 function get_marke:string;
 function get_typ:string;
 function get_baujahr:integer;
 function get_km:integer;
 function get_preis:real;
 function get_all:tauto;
end;

TGarage=class
private
 ar:array of Tauto;
public
 constructor create;
 procedure dazu(m,t:string;b,k:integer;p:real);
 procedure speichern(pfad:string);
 procedure laden(pfad:string);
 function ausgeben:tstringlist;
end;



implementation

//**********tAuto************************

procedure Tauto.set_marke(s: tmystr);
begin
  marke:=s;
end;
procedure Tauto.set_typ(s: tmystr);
begin
  typ:=s;
end;
procedure Tauto.set_baujahr(b: integer);
begin
  baujahr:=b;
end;
procedure Tauto.set_km(k: integer);
begin
  km:=k;
end;
procedure Tauto.set_preis(p: real);
begin
  preis:=p;
end;

procedure Tauto.set_all(au: tauto);
begin
  marke:=au.marke;
  typ:=au.typ;
  baujahr:=au.baujahr;
  km:=au.km;
  preis:=au.preis;
end;
function Tauto.get_marke:string;
begin
  result:=marke;
end;
function Tauto.get_typ:string;
begin
  result:=typ;
end;
function Tauto.get_baujahr:integer;
begin
  result:=baujahr;
end;
function Tauto.get_km:integer;
begin
  result:=km;
end;
function Tauto.get_preis:real;
begin
 result:=preis;
end;
function Tauto.get_all:Tauto;
begin
 result.marke:=marke;
 result.typ:=typ;
 result.baujahr:=baujahr;
 result.km:=km;
 result.preis:=preis;
end;

//++++++tGarage*******************
constructor Tgarage.create;
begin
  inherited create;
  setlength(ar,0);
end;

procedure Tgarage.dazu(m,t:string;b,k:integer;p:real);
var n:integer;
begin
 n:=length(ar);
 setlength(ar,n+1);
 ar[n]:=tauto.Create;
 ar[n].marke:=m;
 ar[n].typ:=t;
 ar[n].baujahr:=b;
 ar[n].km:=k;
 ar[n].preis:=p;
end;

procedure Tgarage.speichern(pfad: string);
var
  i: integer;
  fs:Tfilestream;
begin
  fs:=Tfilestream.create(pfad, fmcreate);
  try
    for i := 0 to High(ar) do
    begin
      fs.Write(ar[i].marke, SizeOf(tmystr));
      fs.Write(ar[i].typ, SizeOf(tmystr));
      fs.Write(ar[i].baujahr, SizeOf(integer));
      fs.Write(ar[i].km, SizeOf(integer));
      fs.Write(ar[i].preis, SizeOf(real));
    end;
  finally
    fs.Free;
  end;
end;


procedure Tgarage.laden(pfad: string);
var fs: TFileStream;
    i: Integer;
begin
  fs := TFilestream.Create(pfad, fmOpenRead);
  try
  SetLength(ar, FS.Size div (2*SizeOf(tmystr)+2*sizeof(integer)+sizeof(real))); // Lnge des Array ber Lnge des Filestreams ermitteln:
    for i:=0 to high(ar) do                                                        // Lange des FS in byte durch Lnge eines Eintrags
    begin
      ar[i]:=Tauto.Create;
      fs.Read(ar[i].marke, SizeOf(tmystr));
      fs.Read(ar[i].typ, SizeOf(tmystr));
      fs.Read(ar[i].baujahr, SizeOf(integer));
      fs.Read(ar[i].km, SizeOf(integer));
      fs.Read(ar[i].preis, SizeOf(real));
    end;
  finally
    fs.free ;
  end;
end;



function Tgarage.ausgeben:tstringlist;
var i:integer;
begin
 result:=Tstringlist.Create;
 for i:=0 to high(ar) do
   begin
     result.add(ar[i].marke);
     result.add(ar[i].typ);
     result.add(inttostr(ar[i].baujahr));
     result.add(inttostr(ar[i].km));
     result.add(floattostr(ar[i].preis));
     result.add('---------------');
   end;
end;

end.
